# # # -------
# # # Generic
# # # -------

# c.JupyterHub.admin_access = True
c.JupyterHub.log_level = "DEBUG"
c.JupyterHub.cookie_max_age_days = 1.0
# c.JupyterHub.redirect_to_server = False
# c.JupyterHub.shutdown_on_logout = True



# # # -------------
# # # Authentication
# # # -------------

# # OAuth2 application info
# # -----------------------
from oauthenticator.generic import GenericOAuthenticator
c.JupyterHub.authenticator_class        = GenericOAuthenticator
c.GenericOAuthenticator.login_service   = "Keycloak SSO"
c.GenericOAuthenticator.client_id       = "{{jupyter_keycloak_client_id}}"
c.GenericOAuthenticator.client_secret   = "{{jupyter_keycloak_client_secret}}"
# # Identity provider info
# # ----------------------
# c.GenericOAuthenticator.authorize_url   = "{{jupyter_keycloak_client_auth_keycloak_url}}/realms/{{jupyter_keycloak_client_realm}}/protocol/openid-connect/auth"
c.GenericOAuthenticator.token_url       = "{{jupyter_keycloak_client_auth_keycloak_url}}/realms/{{jupyter_keycloak_client_realm}}/protocol/openid-connect/token"
c.GenericOAuthenticator.userdata_url    = "{{jupyter_keycloak_client_auth_keycloak_url}}/realms/{{jupyter_keycloak_client_realm}}/protocol/openid-connect/userinfo"
# c.GenericOAuthenticator.userdata_method = "GET"
c.GenericOAuthenticator.userdata_params = {"state": "state"}
c.GenericOAuthenticator.username_key    = "preferred_username"
c.GenericOAuthenticator.scope           = ["openid", "profile"]
c.GenericOAuthenticator.auto_login      = True



# # # -------------
# # # Authorization
# # # -------------

# c.GenericOAuthenticator.manage_groups = True
# c.GenericOAuthenticator.manage_groups = True
c.GenericOAuthenticator.admin_users = {{jupyter_hub_admin_users | list }}
# # c.GenericOAuthenticator.allowed_users = {"admin"} # in format {"username1", "username2"}
c.GenericOAuthenticator.admin_groups = {"admin"}



# # # ---------------
# # # Process Spawner
# # # ---------------
c.Spawner.default_url = '/lab'
c.Spawner.start_timeout = 60
c.Spawner.http_timeout  = 120
c.Spawner.cmd = ['bash', '-l', '-c', 'exec jupyterhub-singleuser "$@"', '--']
c.Spawner.debug = True

# # LocalProcessSpawner
# # -------------------
from jupyterhub.spawner import LocalProcessSpawner
c.JupyterHub.spawner_class = LocalProcessSpawner
c.LocalProcessSpawner.debug = True

# # Authorization
# # -------------
c.LocalProcessSpawner.admin_users = {{jupyter_hub_admin_users | list }}

import pwd, subprocess
def pre_spawn_hook(spawner):
    # print(spawner.get_env())
    username = spawner.user.name
    try:
        pwd.getpwnam(username)
    except KeyError:
        subprocess.check_call(['useradd', '-ms', '/bin/bash', username])

c.Spawner.pre_spawn_hook = pre_spawn_hook
